/***************************************************************************
                          minimumfunction.h  -  description
                             -------------------
    begin                : Tue Nov 12 2002
    copyright            : (C) 2002 by Fungmeista
    email                : mizunoami44@sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef MINIMUMFUNCTION_H
#define MINIMUMFUNCTION_H

#include "mathfunction.h"

/**
  *\author Fungmeista
  *\note This numerically calculates the minimum point on the interval.  This means that for non-continuous functions it will not return correct values of
  *      since the minimum may not be defined.
  */
class MinimumFunction : public MathFunction
{
	public: 
		MinimumFunction(BasicGraph *,int);
		~MinimumFunction();

	protected:
		void calculate_and_draw(QPainter *);
		void draw_stored(QPainter *);

	private:
		double min_x_point, min_y_point;
};

#endif
